! Startup Command File for Mouse

! This first section lists the files (.mob assumed) to be read in by
! the supervisor's bootstrapping loop using the ROM file-reading routine.
! Each file is simply read into memory, and, provided it has no external
! references, is run.  Some of these programs set themselves up as processes,
! others are simply libraries of external procedures and/or extracodes.

mouse:asmlib    ! Extracode library, floating point stuff, etc
mouse:manager   ! Semaphore and mailbox name manager process
mouse:etherp    ! 2MHz ethernet handler process
mouse:termp     ! Terminal handler process
mouse:ether     ! Ethernet interface module
mouse:io_n      ! Null device module
mouse:io_t      ! Terminal device module
mouse:io_f      ! Filestore device module
mouse:implib    ! Imp utility library (including loader and initial CLI)
.               ! End of section marker

! What follows is interpreted by the crude CLI within IMPLIB.
! This section defines logical names (==) and command symbols (=),
! and runs miscellaneous initialisation programs, and eventually the CLI.

! Filestore names

current_filestore==:f:a
a==:f:a
b==:f:b
c==:f:c
d==:f:d
m==:f:m
v==:f:v

! Filestore names (referred to within :F module)
! The extra digit describes protocol variants:
! 0:1976, 1:1986, 2:(as 0 without multi-block reads)

:a==114
:b==015
:c==01B
:d==135
:m==044
:v==272

! Commands compatible with old system

analyse=fmac:analyse
boot=fmac:boot
clean=fmac:clean
clear=fmac:clear
compare=fmac:compare
copy=fmac:copy
credir=fmac:credir
custom=fmac:custom
d=fmac:d
decrypt=des:decrypt
delete=fmac:delete
diary=fmac:diary
disass=fmac:disass
encrypt=des:encrypt
eftp=fmac:eftp
frombin=fmac:frombin
help=fmac:help
id=fmac:id
ie=fmac:ie
laser=fmac:laser
layout=fmac:layout
link2=fmac:link
m68000=mach:f680x0-proc=68000
m68010=mach:f680x0-proc=68010
mail=fmac:mail
nimped=fmac:nimped
pamset=fmac:pamset
pascal=fmac:pascal
pass=fmac:pass
permit=fmac:permit
peruse=fmac:peruse
print=fmac:print
quote=fmac:quote
recover=fmac:recover
rename=fmac:rename
s=mach:gs
search=fmac:search
stamp=fmac:stamp
suggbug=fmac:suggbug
time=fmac:time
to=fmac:to
tobin=fmac:tobin
tod=fmac:tod
trace=fmac:trace
try=fmac:try
v=fmac:e
who=fmac:who
whois=fmac:whois
xscan=fmac:xscan

! Replacement commands

files=mouse:files
forget=mouse:forget
imp2=i:imp22g
imp3=i:imp30
install=mouse:install
log=mouse:log
link3=i:link3
preload=mouse:preload
purge=mouse:purge
remember=mouse:remember
set=mouse:set
setup=mouse:setup
show=mouse:show
takein=mouse:takein
terminit=mouse:terminit

! Command abbreviations

a=analyse
alert=help alert
ass=m68010
bug=suggbug-b
comment=suggbug-c
del=delete
dump=analyse-d
e=v-pre=utils:vecce.pre
s=e-minwin=1-maxwin=1
f=files
i=imp
imp=imp3
l=log
link=link3
oimp=i:oldimp
p=print
pas=pascal
showsym=show com
suggest=suggbug-s
type=copy
ty=type
t=type
u=t $:unos
users=t $:unos
view=help

! Initialisation programs

mouse:install mouse:install.mob,mouse:remember.mob
mouse:install mouse:pam.mob,mouse:ssilib.mob,l:wtlib,l:xecce,mach:hash
mouse:install l:ie,ie:a_sysdep,ie:a_term
mouse:install level1:graph,level1:extgraph,l:paslib,l:maths
mouse:remember l:wtlib.mob,l:xecce.mob,fmac:e.mob,i:imp30.mob,mach:f680x0.mob
mouse:remember l:ie.mob,ie:m_sysdep.mob,ie:m_term.mob,fmac:ie.mob,mouse:log.mob
prompt=}} 
mouse:cli
