{layout of Atom entry}
%constant %integer  AT    OF AE = 0,      {self pointer}
                    ARITY OF AE = 4,      {arity ( = 0 )}
                    INF   OF AE = 4,      {information}
                    FLGS  OF AE = 5,      {flags field}
                    DEFS  OF AE = 8,      {chain of definitions}
                    DB    OF AE = 12,     {chain of data base entries}
                    FC    OF AE = 16,     {functor chain}
                    NXT   OF AE = 20,     {hash chain}
                    ST    OF AE = 24,     {string for atom}
                    SZ    OF AE = 24      {size of atom entry (excluding string)}

{layout of functor entry}
%constant %integer  AT    OF FE = 0,      {atom for this functor}
                    ARITY OF FE = 4,      {arity }
                    INF   OF FE = 4,      {general information field}
                    FLGS  OF FE = 5,      {flags field}
                    DEFS  OF FE = 8,      {clauses for this functor}
                    DB    OF FE = 12,     {data base entries under functor}
                    NXT   OF FE = 16,     {chain of functors with same name}
                    GT    OF FE = 20      {start of general skeleton for this}
                                          {term. Points to this entry.}
%constant %integer  SZ    OF FE = 24      {size( + arity*4 )}

{layout of op entry}
%constant %integer  PRFX OF OE = 0,  {prefix field
                    INFX OF OE = 4,  {infix field
                    PSFX OF OE = 8,  {posfix field
                    SZ   OF OE = 12   {size of entry

%constant %integer  DLPR FLG = 16_8000, {decrease left priority flag}
                    DRPR FLG = 16_4000, {decrease right priority flag}
                    MSK PRTY = 16_3FFF  {mask out priority}

{layout of clause}
%constant %integer  LT  OF CL = 0,     {no. of local and temp. variables}
                    LV  OF CL = 1,     {no. of local vars}
                    GV  OF CL = 2,     {no. of global vars}
                    INF OF CL = 3,     {general inf.}
                    HD  OF CL = 4,     {clause head}
                    BDY OF CL = 8,     {body of clause}
                    ALT OF CL = 12,    {alternatives}
                    SZ  OF CL = 16     {size of entry}

{layout of local frame}
%constant %integer  LCP  OF CF = 0,    {previous choice point}
                    G    OF CF = 4,    {goal}
                    GF   OF CF = 8,    {goal's local frame}
                    GS   OF CF = 12,   {global frame associated with this frame}
                    TR   OF CF = 16,   {tr at entry}
                    INF  OF CF = 20,   {general information}
                    C    OF CF = 24,   {continuation on entry}
                    ALT  OF CF = 28,   {alternatives}
                    SZ   OF CF = 32,   {size}
                    V1   OF CF = 32,   {variables offsets}
                    V2   OF CF = 36,
                    V3   OF CF = 40,
                    V4   OF CF = 44,
                    V5   OF CF = 48,
                    V6   Of CF = 52

%constant %integer INT0 = 16_C0000000,    {it is an integer!}
                   SIGN = 16_20000000,
                   ERASE FLAG = 1,  
                   IN USE FLAG = 2,
                   RESERVED FLAG = 128 + 64 + 32
                
{Command Line Options}

%constant %integer Trace Option     = 2_0000000000000001,
                   Quiet Option     = 2_0000000000000010,
                   Bootstrap Option = 2_0000000000000100

%end %of %file
