! Intel 82786 Definitions file

! Graphics processor opcode definitions

%constinteger -
  absmovop=16_4f00,
  arcexclusionop=16_6800,
  arcinclusionop=16_6900,
  bitbltop=16_6400,
  bitbltmop=16_ae00,
  callop=16_0f00,
  charopaqueop=16_a600,
  chartransparentop=16_a700,
  circleop=16_8e00,
  defbitmapop=16_1a00,
  defcharorientop=16_4e00,
  defcharsetwordop=16_0a00,
  defcharsetbyteop=16_0b00,
  defcharspaceop=16_4d00,
  defcliprectop=16_4600,
  defcolorsop=16_3d00,
  deflogicalopop=16_4100,
  deftextureopaqueop=16_0600,
  deftexturetransparentop=16_0700,
  dumpregop=16_2900,
  enterpickop=16_4400,
  exitpickop=4500,
  haltop=0001,
  incrpointop=16_b400,
  intrgenop=16_0e00,
  lineop=16_5400,
  linkop=16_0200,
  loadregop=16_3400,
  nopop=16_0300,
  pointop=16_5300,
  polygonop=16_7300,
  polylineop=16_7400,
  rectop=16_5800,
  relmovop=16_5200,
  returnop=16_1700,
  scanlinesop=16_ba00

! Display processor opcode definitions

%constinteger -
  dploadregop=16_0400,
  dploadallop=16_0500,
  dpdumpregop=16_0600,
  dpdumpallop=16_0700

! 82786 Memory Map definitions.

%constinteger -
  bitmap base=16_00d00000   {base address of bitmap storage area},
  bitmap size=16_00090000   {576k-size of mem avail for bitmaps },
  dp base=16_00d90000       {base address of dp descriptor area},
  dp size=16_00010000       {64k-size of mem avail for dp descs},
  gp sub base=16_00da0000   {base of gp subroutines},
  gp sub size=16_00010000   {64k of mem avail},
  gp base = 16_00db0000     {base of main routines},
  gp size = 16_00020000     {128k of mem avail},
  font base=16_00dd0000     {base address of font bitmaps},
  font size=16_00010000     {64k-mem avail for font storage},
  array base=16_00de0000    {base address of polygon,char arrays},
  array size=16_00010000    {64k-mem avail for array storage},
  palette base=16_00dff000  {base address of TMS34070 palette},
  palette size=16_00000020  {32 bytes mem used by palette},
  general base=16_00dff020  {base address of general workspace},
  stack base=16_00dffffd    {base address of gp stack-grows down},
  register base=16_00c00000 {base address of 82786 register block},
  register size=16_00000080 {mem occupied by 82786 memory}

! Addresses of important BIU memory locations

%constinteger -
  BIU relocation reg=16_00c00000,
  BIU control reg=16_00c00004,
  BIU refresh control reg=16_00c00006,
  BIU DRAM control reg=16_00c00008,
  BIU display priority=16_00c0000a,
  BIU graphics priority=16_00c0000c,
  BIU external priority=16_00c0000e

! Addresses of gp, dp registers

%constinteger -
  gp status=16_00c00020,
  dp status=16_00c00040,
  default video=16_00c0004a
