




























$a invert=0
$a tab=5,10,15,20,25
$b10
$l1um
Microware Model 32 Prom Programmer/Emulator
$b3
$l1um
EUCSD Operating Instructions
$b3
$l1um
M. R. King
$b
$l1um
August 1980
$n
$p This manual describes the Microware Model
32 PROM programmer and emulator as modified by the author
for use in the Edinburgh Universities Department of Computer
Science.
Large parts of this manual are taken from the manufacturers
original documentation.
$b2
$lu
General Description
$p The instrument consists of the following:
$p A simple keypad consisting of a
hexadecimal pad (0 to F) and three other keys on the right
hand side; _Function (red), _Address and _Data (both yellow).
$p A three hexadecimal digit display that indicates the
address, data or current entry being keyed.
$p A plug in personality module which determines the Family of PROMs
to be emulated or programmed. This carries the following:
$a indent=1
$p A 'configurator plug' which determines the specific type
PROM to be emulated. This is a %14 pin DIL module situated
on the top left of the personality module.
$p A DIL socket situated on the underside of the personality
into which a ribbon cable may be pluged. This cable carries
a second plug which is used in place of the emulated PROM.
$p A second configurator plug which determines the specific
type of PROM to be programmed. This is a %16 pin DIL module
situated in the top centre of the personality module.
%p A zero insertion force
socket used to hold PROMs during programming operations.
$a indent=0
$p At the rear of the instrument is a mains supply switch
and an EIA/RS232 socket providing a serial interface to a
host computer.
$p Internally the instrument conatins a 4k byte memory
referred to as the 'emulator memory'. This holds the
contents of a PROM being emulated or future contents
of a PROM to be programmed. It may be loaded from a host
computer and edited using the hexadecimal keypad.
$b2
$l1ucm
WARNINGS!
$b2
1. Switch off the mains before changing or removing the
plug in personality modules. This warning does not apply to the
configurator plugs.
$b1
2. Ensure configurator plugs for the correct PROM are
inserted correctly before inserting PROMs into the
programming socket or the emulation cable into any
other equipment. Note the instrument may be configured
to program PROMs of one type and emulate a different type.
$b1
3. Make sure configurator plugs, emulation cables and
PROMs are inserted the right way round.
$b1
4. Make sure any special functions have been entered
correctly before trying to use them.
$n
$l1um
Operating Instructions
$p Any one of several functions is selected by first
keying the _Function key followed by another key
corresponding to the required function.
The possible functions are as follows:
$a indent=5
$b1 $i0 0 Set all 00
$t5 Clears all of the emulator memory to 00 and then goes
to the enter data function at address 000.
$b1 $i0 1 Set all FF
$t5 Sets all of the emulator memory to FF and then goes
to the enter data function at address 000.
$b1 $i0 2 Read
$t5 Copies the contents of the PROM into the emulator
memory and then goes to the enter data function at address
000.
$b1 $i0 3 Verify
$t5 Compares the contents of the PROM and the emulator
memory without changing either. If they are equal
it then goes to the enter data function at address 000.
If a difference is found, the display flashes the address
and differing PROM contents alternately.
$b1 $i0 4 Test Blank
$t5 Checks to see if the PROM contents are in their
unprogrammed state ( all FF). The result is the same as
the verify function.
$b1 $i0 7 Special Function.
$t5 Executes the 'Special Function' entered using the 'C'
function. See the section of this manual 'Using special functions'.
$b1 $i0 8 Program
$t5 Programs all of the PROM with the contents of the
appropriate area of emulator memory. It then performs the
verfiy function and goes to the enter data function at address 000.
$b1 $i0 9 Fast Program
$t5 This is the same as the program function except that for
PROMs requiring repetative passes through the PROM, just 10$%
of the required passes are performed. This is used to speed
throughput in applications not requiring long retention of
the PROM contents.
$b1 $i0 A Serial input
$t5 Loads the emulator memory from a host computer.
See the section of this manual 'Loading From A Host Computer'.
$b1 $i0 B Serial output
$t5 Sends the contents of emulator memory to a host computer.
See the section of this manual 'Sending To A Host Computer'.
$b1 $i0 C Special entry
$t5 Enters special function data into the instrument.
See the sections of this manual 'Using special functions' and
'Entering memory contents'.
$b1 $i0 D Development system
$t5 Places the instrument under the control of a host computer.
$b1 $i0 E Enter Data
$t5 Enables entry and editing of data into the emulator memory.

See the section of this manual 'Entering memory contents'.
$b1 $i0 F Emulate
$t5 Emulator memory acts as a PROM connected to the emulator
header plug. The display is blanked to indicate this mode.
$a indent=0
$b2 $l1umc
Warning!
$p Note that some functions cause the whole of emulator memory
to be changed. Great care should be taken to select only the
required function after pressing the red _Function key.
$n
$l1u
Entering memory contents
$p The enter function is selected by keying _Function followed
by either _C for special function entry or _E for emulator
memory entry. It enables data to be keyed into memory or the
contents of memory to be examined or changed. This function
is used as follows:
$b1
$l1
Entering Data
$a indent=1
$b1 $i0 1.
$t1 When the enter function is first selected the 'current
address' will be set to 000 and the contents of that location
displayed.
$b1 $i0 2.
$t1 Data may then be entered. as soon as a hexadecimal key
is pressed the display changes to indicate the current entry.
Note that leading 0's need not be entered.
$b1 $i0 3.
$t1 No 'Rubout' key is provided because errors may be corrected
by simply rekeying the right data, the wrong ones being shifted
left off the display.
$b1 $i0 4.
$t1 When the correct data entry is displayed it may be entered
into the current address by typing the yellow _Data key.
The current address is then incremented and the contents of
new address displayed.
$b1
$l1
Ca
Changing the current address
$b1
The current address at which data is entered into memory may
be changed as follows:
$b1 $i0 1.
$t1 Key in up to three hexadecimal digits to form the required
address. leading 0's need not be entered. Only the last two
digits are displayed but the other will still be remembered
as part of the required address.
$b1 $i0 2.
$t1 An incorrect entry can be replaced by simply keying
in the correct three digits again. Be careful to correct
all three digits, not just the displayed ones.
$b1 $i0 3.
$t1 When the address entry is correct press the yellow
_Address key which will display the new current address.
When this key is released the contents of this location
will be displayed.
$b1
$l1
Examining Data and Addresses
$b1
The data at the current address is always displayed until
a new entry from the keyeboard is started.
$b1
Succesive memory locations can be examined by repeatitive
keying of the yellow _Data key, which only steps the
current address if no data entry is made. Changes to the
data are made only when new data is keyed before pressing
the yellow _Data key.
$b1
Pressing the yellow _Address key without a data entry
first causes the current address to be displayed until
the key is released. When released the display reverts
to the contents of the current location.
